package nckd.yjk.yj.plugin.docLibrary.form;

import com.alibaba.druid.util.StringUtils;
import kd.bos.algo.DataSet;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.BillShowParameter;
import kd.bos.cache.CacheFactory;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.operate.Attachment;
import kd.bos.entity.operate.Donothing;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.IClientViewProxy;
import kd.bos.form.ShowType;
import kd.bos.form.control.AttachmentPanel;
import kd.bos.form.control.Button;
import kd.bos.form.control.Control;
import kd.bos.form.control.events.ClickListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.id.ID;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.url.UrlService;
import kd.sdk.plugin.Plugin;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.*;

import static kd.bos.cache.ehcache.syncstatus.MemoryCacheSyncStatusMange.getUid;

/**
 * 父界面
 */
public class ApplyBillPlugin extends AbstractBillPlugIn implements Plugin, ClickListener {
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        super.afterDoOperation(args);
        Integer b=1;
        if(args.getOperateKey().equals("yinyong")){

            Integer a=1;
            DynamicObject[] nckd_requisitionlists = BusinessDataServiceHelper.load("nckd_requisitionlist", "id,billno", null);
            FormShowParameter showParameter=new FormShowParameter();
            showParameter.setFormId("nckd_reference");
            showParameter.setCaption("要件列表");
            showParameter.setCloseCallBack(new CloseCallBack(this,"officecount"));
            showParameter.getOpenStyle().setShowType(ShowType.Modal);
            this.getView().showForm(showParameter);

        }


//        if(args.getOperateKey().equals("check")){
//            AttachmentPanel attachmentpanel = this.getView().getControl("attachmentpanel");
//            List<Map<String, Object>> attachmentData = attachmentpanel.getAttachmentData();
////            List<Map<String,Object>> attachmentpanel = (List<Map<String,Object>>)this.getModel().getValue("attachmentpanel");
//            for (Map<String, Object> map : attachmentData) {
//                String uid = (String) map.get("uid");
//                String url = (String) map.get("url");
//                String name = (String) map.get("name");
//                String size = (String) map.get("size");
////                String fattachmentpanel = (String) map.get("fattachmentpanel");
//                Integer entityNum =  (Integer) map.get("entityNum");
//                String lastModified = (String) map.get("lastModified");
//                String status = (String) map.get("status");
//                String client = (String) map.get("client");
//
//            }
//            Integer a=1;
//
//
//        }


    }

    @Override
    public void closedCallBack(ClosedCallBackEvent e) {
        super.closedCallBack(e);

        String callBackpage = e.getActionId();
            if("officecount".equals(callBackpage)){
           DynamicObjectCollection dynamicObjectCollection= (DynamicObjectCollection)e.getReturnData();
           if(dynamicObjectCollection!=null){
               for (DynamicObject dynamicObject : dynamicObjectCollection) {
                   String number = dynamicObject.getString("nckd_number");

                   try {

                       DynamicObjectCollection dynamicObjects=(DynamicObjectCollection)dynamicObject.get("nckd_attachmentfield");

                       AttachmentPanel attachmentPanel =this.getControl("nckd_attachmentpanel");
                       List<Map<String,Object>> attachments=new ArrayList<>();
                       HashMap<String,Object> map;

                       if(dynamicObjects!=null&&dynamicObjects.size()>0){
                           for (DynamicObject attachmentField : dynamicObjects) {
                               
                               
//                              获取附件编码
//                               DynamicObject sourceAttachment = BusinessDataServiceHelper.loadSingle(attachmentField.getDynamicObject("fbasedataId").getPkValue(), EntityMetadataCache.getDataEntityType("bd_attachment"));
//                               String number = sourceAttachment.getString("number");


                               map=new HashMap<>();
                               //获取附件字段中的单个附件
                               DynamicObject fbasedataid = attachmentField.getDynamicObject("fbasedataid");
                               map.put("type", fbasedataid.getString("type"));
                               //获取附件inputstream上传到缓存服务（附件面板数据需要上传到缓存服务中，返回非持久化的url）
                               InputStream inputStream = FileServiceFactory.getAttachmentFileService().getInputStream(fbasedataid.getString("url"));
                               String tempUrl =
                                       CacheFactory.getCommonCacheFactory().getTempFileCache().saveAsFullUrl(fbasedataid.getString("name"), new BufferedInputStream(inputStream), 2 * 3600);
                               //临时url
                               map.put("url", tempUrl);
                               //uid
                               map.put("uid", number);
                               //name
                               map.put("name", fbasedataid.getString("name"));
                               //size
                               map.put("size", fbasedataid.get("size"));
//                    map.put("fattachmentpanel", "attachmentpanel");
                               //entityNum
//                               map.put("entityNum", getView().getEntityId());
                               //lastModified
                               map.put("lastModified", new Date().getTime());
                               map.put("status", "success");
                               //client
                               map.put("client", "web");
//                               map.put("entityNum",number);


                               attachments.add(map);
//                    AttachmentServiceHelper.upload(getView().getEntityId(),this.getModel().getValue("id"),"attachmentpanel",attachments);
                               attachmentPanel.upload(attachments);
                               // 刷新附件面板，才会重新加载数据
                               this.getView().updateView("nckd_attachmentpanel");

                           }
                       }

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                       List<Map<String, Object>> attachmentData = attachmentPanel.getAttachmentData();
//
//
//                       for (Map<String, Object> attachmentMap : attachmentData) {
//                           String visiablePreview = "1";//是否显示预览按钮
//                           String visiableDownload = "0";//是否显示下载按钮
//                           String visiableDelete = "1";//是否显示删除按钮
//                           String visiableRename = "1";//是否显示重命名按钮
//                           attachmentMap.put("visible",visiablePreview + visiableDownload + visiableDelete + visiableRename);
//                       }
//
//                       IClientViewProxy clientViewProxy = getView().getService(IClientViewProxy.class);
//                       clientViewProxy.setEntryProperty("attachmentpanel","data",attachmentData);
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//                    break;
                   } catch (Exception ex) {
                       throw new RuntimeException(ex);
                   }





//            //根据附件字段数据构造附件面板数据
//            Map<String, Object> attachemnts = new HashMap<>();
//            List<Map<String, Object>> attachmentData3 = buildAttachmentDataFromEdit(dynamicObjects);
//            //key:目标附件面板标识，value:目标附件面板附件数据
//            attachemnts.put("attachmentpanel", attachmentData3);
//
//            /**
//             * 根据附件字段数据构造附件面板数据
//             * @param sourceAttachCol
//             * @return
//             */
//            private List<Map<String, Object>> buildAttachmentDataFromEdit(DynamicObjectCollection sourceAttachCol) {
//                List<Map<String, Object>> attachDataList = new ArrayList<>();
//                sourceAttachCol.forEach(attach -> {
//                    DynamicObject attachObj = attach.getDynamicObject("fbasedataid");
//                    Map<String, Object> attachMap = new HashMap<>();
//                    //description
//                    attachMap.put("description", attachObj.getString("description"));
//                    attachMap.put("type", attachObj.getString("type"));
//                    //获取附件inputstream上传到缓存服务
//                    InputStream inputStream = FileServiceFactory.getAttachmentFileService().getInputStream(attachObj.getString("url"));
//                    String saveUrl = CacheFactory.getCommonCacheFactory().getTempFileCache().saveAsFullUrl(attachObj.getString("name"), new BufferedInputStream(inputStream), 2*3600);
//                    //url
//                    attachMap.put("url", saveUrl);
//                    //uid
//                    attachMap.put("uid", getUid());
//                    //name
//                    attachMap.put("name", attachObj.getString("name"));
//                    //size
//                    attachMap.put("size", attachObj.get("size"));
//                    attachMap.put("fattachmentpanel", "attachmentpanel");
//                    //entityNum
//                    attachMap.put("entityNum", getView().getEntityId());
//                    attachMap.put("billPkId", String.valueOf(getModel().getValue("id")));
//                    //lastModified
//                    attachMap.put("lastModified", new Date().getTime());
//                    attachMap.put("status", "success");
//                    //client
//                    attachMap.put("client", null);
//                    attachDataList.add(attachMap);
//                });
//                return attachDataList;
//             }

               }
           }



        }


    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        AttachmentPanel panel = this.getView().getControl("nckd_attachmentpanel");
        List<Map<String, Object>> attachmentData = panel.getAttachmentData();


        for (Map<String, Object> attachmentMap : attachmentData) {
            String visiablePreview = "1";//是否显示预览按钮
            String visiableDownload = "0";//是否显示下载按钮
            String visiableDelete = "1";//是否显示删除按钮
            String visiableRename = "1";//是否显示重命名按钮
            attachmentMap.put("visible",visiablePreview + visiableDownload + visiableDelete + visiableRename);
        }

        IClientViewProxy clientViewProxy = getView().getService(IClientViewProxy.class);
        clientViewProxy.setEntryProperty("nckd_attachmentpanel","data",attachmentData);



    }
}