package nckd.yjk.yj.plugin.docLibrary.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.operate.Donothing;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickListener;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.list.AbstractList;
import kd.bos.list.IListView;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 标准单据列表插件
 */
public class BatchdownloadListPlugin extends AbstractListPlugin implements Plugin, ItemClickListener {
    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        super.afterDoOperation(args);
        Integer b = 1;
        if (args.getOperateKey().equals("batchdl")) {
            Donothing donothing = (Donothing) args.getSource();
            Long id = (Long) donothing.getListFocusRow().getPrimaryKeyValue();
            String formID = donothing.getEntityId();
            DynamicObject obj = BusinessDataServiceHelper.loadSingle(id, formID);



            FormShowParameter showParameter = new FormShowParameter();
            Map<String, Object> hashMap = new HashMap<>();
            hashMap.put("formId",obj.getDataEntityType().getName());
            hashMap.put("id",obj.getPkValue());
            showParameter.setCustomParams(hashMap);
            showParameter.setFormId("nckd_batchdl");
            showParameter.setCaption("文件下载");
            showParameter.setCloseCallBack(new CloseCallBack(this, "officecount"));
            showParameter.getOpenStyle().setShowType(ShowType.Modal);

            this.getView().showForm(showParameter);

        }
    }
}