package nckd.yjk.yj.plugin.docLibrary.operate;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.operate.Donothing;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 生成中间单
 */
public class CreateInterPlugin extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        // 获取当前日期
        Date date = new Date();




        super.beginOperationTransaction(e);
        DynamicObject[] dynamicObjects=e.getDataEntities();
        String FormId=dynamicObjects[0].getDataEntityType().getName();
        Integer a=1;
        for (int i = 0; i < dynamicObjects.length; i++) {
            String nckd_appcoding = dynamicObjects[i].getString("billno");
            QFilter qFilter=new QFilter("nckd_appcoding", QCP.equals,nckd_appcoding);
            DeleteServiceHelper.delete("nckd_yinyongbiao", new QFilter[]{qFilter});
            //获取单据中附件面板信息
            List<Map<String, Object>> atts = AttachmentServiceHelper.getAttachments(dynamicObjects[i].getDataEntityType().getName(),dynamicObjects[i].getPkValue(), "attachmentpanel");
            //遍历文件
            for (Map<String, Object>  att: atts) {
                String uid = (String) att.get("uid");
                String url = (String) att.get("url");
                String number = (String) att.get("uid");

                QFilter qFilter1 = new QFilter("number", QCP.equals, number);
                DynamicObject dynamicObject1 = BusinessDataServiceHelper.loadSingle("nckd_requisitionlist", "id", new QFilter[]{qFilter1});
                if (dynamicObject1!=null) {


                    String name = (String) att.get("name");
//            String name = dynamicObjects[i].getDynamicObject("nckd_requirements").getString("name");
                    LocaleString localeString = new LocaleString();
                    localeString.setLocaleValue_zh_CN(name);

//            Long nckd_elecoding=(Long)att.get("attPkId");
//            String nckd_elecoding = dynamicObjects[i].getDynamicObject("nckd_requirements").getString("number");


                    DynamicObject newDangerRepository = BusinessDataServiceHelper.newDynamicObject("nckd_yinyongbiao");
                    long currentUserId = UserServiceHelper.getCurrentUserId();

                    newDangerRepository.set("billstatus", "A");
                    newDangerRepository.set("creator", currentUserId);
                    newDangerRepository.set("nckd_elecoding", number);
                    newDangerRepository.set("nckd_appcoding", nckd_appcoding);
                    newDangerRepository.set("nckd_textname", name);
                    newDangerRepository.set("nckd_appname", FormId);
                    newDangerRepository.set("nckd_appname", FormId);
                    newDangerRepository.set("nckd_yinyongperson", currentUserId);
                    newDangerRepository.set("nckd_yinyongdate", date);

                    QFilter qFilter369 = new QFilter("number", QCP.equals, number);
                    //更新引用次数
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("nckd_requisitionlist", new QFilter[]{qFilter369});
                    int nckd_yynum = dynamicObject.getInt("nckd_yynum");
                    dynamicObject.set("nckd_yynum", nckd_yynum + 1);
                    SaveServiceHelper.saveOperate("nckd_requisitionlist", new DynamicObject[]{dynamicObject}, OperateOption.create());


                    try {
                        OperationResult repositoryResult = OperationServiceHelper.executeOperate("save", "nckd_yinyongbiao",
                                new DynamicObject[]{newDangerRepository}, OperateOption.create());
                    } catch (Exception ex) {
                        throw new RuntimeException(ex);
                    }

                }
            }

        }
    }
}