package fi.em.opplugin;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.operation.OperationServiceHelper;

/**
 * @author cjz
 * @date 2024/11/26 15:21
 * @description:核定提交前触发
 */
public class TravelTotalOpPlugin extends AbstractOperationServicePlugIn{

    //核定提交按钮
    private static String approvesubmit="approvesubmit";
    //付款给前置按钮标识
    private static String save="save";


    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        DynamicObject[] dynamicObjects = e.getDataEntities();
        //当前操作单据
        DynamicObject curentDy=dynamicObjects[0];
        Long id= curentDy.getLong("id");
        String operationKey = e.getOperationKey();
        //核定提交前调用保存操作
        if (approvesubmit.equals(operationKey)) {
            //调用保存操作
            OperationServiceHelper
                    .executeOperate("save","er_tripreimbursebill",new Object[]{id},OperateOption.create());
        }
    }

}
