package nckd.yjk.yj.plugin.docLibrary.operate;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.DeleteServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;
import org.apache.commons.lang3.StringUtils;

/**
 * 删除中间单
 */
public class DeleteInterPlugin extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        super.beginOperationTransaction(e);
        DynamicObject[] dynamicObjects=e.getDataEntities();
        Integer a=1;
        for (int i = 0; i < dynamicObjects.length; i++) {

           //nckd_appcoding 是引用要件单的单据编号
            String nckd_appcoding = dynamicObjects[i].getString("billno");
            QFilter qFilter1 = new QFilter("nckd_appcoding", QCP.equals, nckd_appcoding);


            DynamicObject dynamicObject1 = BusinessDataServiceHelper.loadSingle("nckd_yinyongbiao", new QFilter[]{qFilter1});

            if(dynamicObject1!=null) {

                String nckd_elecoding = dynamicObject1.getString("nckd_elecoding");


                QFilter qFilter369 = new QFilter("number", QCP.equals, nckd_elecoding);
                //更新引用次数
                DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("nckd_requisitionlist", new QFilter[]{qFilter369});

                int nckd_yynum = dynamicObject.getInt("nckd_yynum");
                dynamicObject.set("nckd_yynum", nckd_yynum - 1);
                SaveServiceHelper.saveOperate("nckd_requisitionlist", new DynamicObject[]{dynamicObject}, OperateOption.create());

                QFilter qFilter = new QFilter("nckd_appcoding", QCP.equals, nckd_appcoding);
                DeleteServiceHelper.delete("nckd_yinyongbiao", new QFilter[]{qFilter});
            }
        }
    }
}