package nckd.yjk.yj.plugin.docLibrary.operate;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

public class yaojianformcreatePlugin extends AbstractOperationServicePlugIn implements Plugin {
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        super.beginOperationTransaction(e);
        DynamicObject[] dynamicObjects=e.getDataEntities();
        Integer a=1;
        for (int i = 0; i < dynamicObjects.length; i++) {
            DynamicObject info=dynamicObjects[i];
//            DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(),dynamicObjects[i].getDynamicObjectType().getName());
            Long orgbaseid=info.getDynamicObject("nckd_orgbase").getLong("id");
            Long creator=info.getDynamicObject("creator").getLong("id");
            Long auditor= UserServiceHelper.getCurrentUserId();
            Long org=info.getDynamicObject("nckd_orgfield1").getLong("id");
            Date applydate = info.getDate("nckd_applydate");
            DynamicObjectCollection objectCollection = info.getDynamicObjectCollection("entryentity");
            for (DynamicObject dynamicObject : objectCollection) {

                Long nckd_yjclass = dynamicObject.getDynamicObject("nckd_yjclass").getLong("id");
                String classname=dynamicObject.getDynamicObject("nckd_yjclass").getString("name");
//                boolean nckd_isrepeatcite = dynamicObject.getBoolean("nckd_isrepeatcite");
//                boolean nckd_iscitebynotupload = dynamicObject.getBoolean("nckd_iscitebynotupload");
//                boolean nckd_iscross = dynamicObject.getBoolean("nckd_iscross");
                boolean nckd_isdownloadable = dynamicObject.getBoolean("nckd_isdownloadable");
                boolean nckd_isshared = dynamicObject.getBoolean("nckd_isshared");
                String nckd_attname = dynamicObject.getString("nckd_attname");
                String nckd_atttype = dynamicObject.getString("nckd_atttype");
                String nckd_attsize = dynamicObject.getString("nckd_attsize");
                LocaleString localeString=new LocaleString();
                localeString.setLocaleValue_zh_CN(nckd_attname);

                DynamicObject newDangerRepository = BusinessDataServiceHelper.newDynamicObject("nckd_requisitionlist");
                newDangerRepository.set("status","C");
                newDangerRepository.set("name",localeString);
                newDangerRepository.set("enable",1);
                newDangerRepository.set("createorg",org);
                newDangerRepository.set("useorg",org);
                newDangerRepository.set("creator",creator);
                newDangerRepository.set("nckd_userfield",auditor);
                newDangerRepository.set("nckd_applydate",applydate);
                newDangerRepository.set("nckd_yjclass",nckd_yjclass);
//                newDangerRepository.set("nckd_isrepeatcite",nckd_isrepeatcite);
//                newDangerRepository.set("nckd_iscitebynotupload",nckd_iscitebynotupload);
//                newDangerRepository.set("nckd_iscross",nckd_iscross);
                newDangerRepository.set("nckd_isdownloadable",nckd_isdownloadable);
                newDangerRepository.set("nckd_isshared",nckd_isshared);
                newDangerRepository.set("nckd_atttype",nckd_atttype);
                newDangerRepository.set("nckd_attsize",nckd_attsize);
                newDangerRepository.set("nckd_orgbase",orgbaseid);

                if(classname.equals("知识库")){
                    newDangerRepository.set("nckd_isshared",true);
                }

                List<Object> attchIdSet = new ArrayList<>();
                DynamicObjectCollection picCo = dynamicObject.getDynamicObjectCollection("nckd_attachmentfield");
                if (picCo != null && !picCo.isEmpty()) {
                    picCo.forEach(attach -> {
                        attchIdSet.add(attach.getDynamicObject("fbasedataId").getPkValue());
                    });
                    DynamicObject[] sourceAttachments = BusinessDataServiceHelper.load(attchIdSet.toArray(), EntityMetadataCache.getDataEntityType("bd_attachment"));

                    DynamicObjectCollection targetAttachCol = newDangerRepository.getDynamicObjectCollection("nckd_attachmentfield");
                    Arrays.asList(sourceAttachments).forEach(attachObj ->
                            targetAttachCol.addNew().set("fbasedataid", attachObj)
                    );
                }

                //保存

                OperationResult repositoryResult = OperationServiceHelper.executeOperate("save", "nckd_requisitionlist",
                        new DynamicObject[]{newDangerRepository}, OperateOption.create());

                Integer o=0;





            }
        }



    }
}
