package nckd.yjk.yj.plugin.docLibrary.utils;

import com.alibaba.fastjson.JSONObject;

/*
 * 获取APPTOKEN
 */
public class AppLoginService {
	
	private static final String path  = "/api/getAppToken.do";
	
	private static final AppLoginService service = new AppLoginService();
	
	private AppLoginService() {}
	
	//静态工厂方法   
    public static AppLoginService getService() {  
        return service;
    }
    
    public String getAppToken(String REMOTEHOST) {
    	//获取APPTOKEN
		String url = REMOTEHOST + path;
		// appId & appSecuret & tenantid & accountId 需修改
		String data = "{\"appId\": \"EAS\""
				+ ",\"appSecuret\": \"123456\""
				+ ",\"tenantid\": \"ierp\""
				+ ",\"accountId\": \"1557233840063393244\""
				+ ",\"language\": \"zh_CN\"}";
		String responseStr = null;
		try {
			responseStr = HttpService.getService().doPostByHttpClient(url, data);
		} catch (Exception e) {
			e.printStackTrace();
		}
		JSONObject json  = JSONObject.parseObject(responseStr);
		String appToken  = json.getJSONObject("data").getString("app_token");
		return appToken;
    }
    
}
