package nckd.yjk.yj.plugin.docLibrary.utils;

import com.alibaba.fastjson.JSONObject;

public class UserLoginService {

	private static final String path = "/api/login.do";
	
	private UserLoginService() {}
	
    private static final UserLoginService service = new UserLoginService();
    
    //静态工厂方法   
    public static UserLoginService getService()  {  
        return service;  
    }
    
	public String getAccessToken(String REMOTEHOST, String appToken) {
		//获取用户token
		String url = REMOTEHOST + path;
		// user & tenantid & accountId 需修改
		String data = "{\"user\": \"17299999999\""
				+ ",\"apptoken\": \""+appToken+"\""
				+ ",\"tenantid\": \"ierp\""
				+ ",\"accountId\": \"1557233840063393244\""
				+ ",\"usertype\": \"Mobile\"}";
		String responseStr = null;
		try {
			responseStr = HttpService.getService().doPostByHttpClient(url, data);
		} catch (Exception e) {
			e.printStackTrace();
		}	
		JSONObject json  = JSONObject.parseObject(responseStr);
		String accessToken  = json.getJSONObject("data").getString("access_token");
		return accessToken;
	}
}
